#include "Memory.hpp";
#include "Maths.hpp";
#include "ObfuscateString.h"
#include <string>
#include <spdlog/spdlog.h>
#include <spdlog/sinks/rotating_file_sink.h>
#include <filesystem>
#include <safetyhook.hpp>


// Constants
const std::string PLUGIN_NAME = "HellIsUs";
const std::string PLUGIN_LOG = PLUGIN_NAME + ".log";
const std::string gameExecutable = "HellIsUs-Win64-Shipping.exe";
const float baseAspect = 1.777777791;
const float PDA_FOV = 21; // FOV must not be modified when switching to PDA to keep reading possible

// Logger
std::shared_ptr<spdlog::logger> logger;

// Screen informations
static int screenWidth = GetSystemMetrics(SM_CXSCREEN);
static int screenHeight = GetSystemMetrics(SM_CYSCREEN);
static float aspectRatio = (float)screenWidth / screenHeight;

// Plugin states
static bool AOBScanDone = false;
static bool g_fix_enabled = false;
static bool g_fov_fix_enabled = false;
static bool g_aspect_fix_enabled = false;
static bool g_DOF_fix_enabled = false;
static bool g_CA_fix_enabled = false;
static bool g_Vignetting_fix_enabled = false;
static bool g_Fog_fix_enabled = false;
static int g_AdditionalFOVValue = 0;

// Shared values
static float g_FOV_In = 0;
static float g_Compensated_FOV = 0;
static float g_FOV_Out = 0;

// AOB Scan pointers
static uint8_t* FOVaddress = nullptr;
static uint8_t* FOVOtheraddress = nullptr;
static uint8_t* Aspectaddress = nullptr;
static uint8_t* DOFaddress = nullptr;
static uint8_t* CAaddress = nullptr;
static uint8_t* Vignettingaddress = nullptr;
static uint8_t* Fogaddress = nullptr;

// Hooking
static SafetyHookMid FOVHook{};
static SafetyHookMid AspectHook{};
static SafetyHookMid FogHook{};

// Prototypes 
static void FOVFixEnabled(bool fix_enabled);
static void AspectFixEnabled(bool fix_enabled);
static void DOFFixEnabled(bool fix_enabled);
static void CAFixEnabled(bool fix_enabled);
static void VignettingFixEnabled(bool fix_enabled);
static void FogFixEnabled(bool fix_enabled);

extern "C" __declspec(dllexport) void SetFixEnabled(bool enabled)
{
    g_fix_enabled = enabled;
    if (g_fix_enabled && !AOBScanDone) {
        logger->info("--------------- AOB scan started ---------------");
        if (FOVaddress == nullptr) {
            constexpr auto FOVStringObfuscated = make_obfuscated<0x4A>("77 ?? 48 ?? ?? FF ?? ?? ?? ?? ?? F3 0F ?? ?? ?? 48");
            FOVaddress = Memory::AOBScan(gameExecutable, FOVStringObfuscated.decrypt(), PAGE_EXECUTE_READ);
            //"HellIsUs-Win64-Shipping.exe" + 3C8E924 - 48 8B 01            - mov rax, [rcx]
            //"HellIsUs-Win64-Shipping.exe" + 3C8E927 - FF 90 60 07 00 00   - call qword ptr[rax + 00000760]
            //"HellIsUs-Win64-Shipping.exe" + 3C8E92D - F3 0F 10 40 30      - movss xmm0, [rax + 30]
            //"HellIsUs-Win64-Shipping.exe" + 3C8E932 - 48 83 C4 28         - add rsp, 28
            //"HellIsUs-Win64-Shipping.exe" + 3C8E936 - C3                  - ret

            if (!FOVaddress)
                logger->warn("FOV signature not found. Maybe your game has been updated and is no more compatible with this plugin.");
            else {
                logger->info("FOV signature found at address: 0x{:X}.", reinterpret_cast<uintptr_t>(FOVaddress));
                FOVaddress += 0x10;
            }
        }

        if (Aspectaddress == nullptr) {
            constexpr auto AspectStringObfuscated = make_obfuscated<0x4A>("E9 ?? ?? ?? ?? CC CC CC CC CC CC 48 89 ?? ?? ?? 57 48 83 ?? ?? 0F ?? ?? 48 ?? ?? 48");
            Aspectaddress = Memory::AOBScan(gameExecutable, AspectStringObfuscated.decrypt(), PAGE_EXECUTE_READ);
            //"HellIsUs-Win64-Shipping.exe" + 3453EBA - 89 41 58    - mov[rcx + 58], eax
            //"HellIsUs-Win64-Shipping.exe" + 3453EBD - 8B 42 5C    - mov eax, [rdx + 5C]
            //"HellIsUs-Win64-Shipping.exe" + 3453EC0 - 89 41 5C    - mov[rcx + 5C], eax <<= Aspect ratio
            //"HellIsUs-Win64-Shipping.exe" + 3453EC3 - 48 8D 42 60 - lea rax, [rdx + 60]
            //"HellIsUs-Win64-Shipping.exe" + 3453EC7 - 48 83 C1 60 - add rcx, 60

            if (!Aspectaddress)
                logger->warn("Aspect ratio ratio signature not found. Maybe your game has been updated and is no more compatible with this plugin.");
            else {
                logger->info("Aspect ratio signature found at address: 0x{:X}.", reinterpret_cast<uintptr_t>(Aspectaddress));
                Aspectaddress = Aspectaddress + 0x8b;
            }
        }

        if (DOFaddress == nullptr) {
            constexpr auto DOFStringObfuscated = make_obfuscated<0x4A>("74 ?? 48 ?? ?? 8B ?? ?? 48 ?? ?? E8");
            DOFaddress = Memory::AOBScan(gameExecutable, DOFStringObfuscated.decrypt(), PAGE_EXECUTE_READ);
            //"HellIsUs-Win64-Shipping.exe" + 26ABA27 - 74 03           - je "HellIsUs-Win64-Shipping.exe" + 26ABA2C
            //"HellIsUs-Win64-Shipping.exe" + 26ABA29 - 48 8B C3        - mov rax, rbx
            //"HellIsUs-Win64-Shipping.exe" + 26ABA2C - 8B 34 30        - mov esi, [rax + rsi]
            //"HellIsUs-Win64-Shipping.exe" + 26ABA2F - 48 8B CF        - mov rcx, rdi
            //"HellIsUs-Win64-Shipping.exe" + 26ABA32 - E8 D9 C4 6C 01  - call "HellIsUs-Win64-Shipping.exe" + 3D77F10

            if (!DOFaddress)
                logger->warn("DOF signature not found. Maybe your game has been updated and is no more compatible with this plugin.");
            else {
                logger->info("DOF signature found at address: 0x{:X}.", reinterpret_cast<uintptr_t>(DOFaddress));
                DOFaddress += 0x5;
            }
        }

        if (CAaddress == nullptr) {
            constexpr auto CAStringObfuscated = make_obfuscated<0x4A>("7F ?? 44 89 ?? ?? ?? ?? ?? 43 ?? ?? ?? 39 05");
            CAaddress = Memory::AOBScan(gameExecutable, CAStringObfuscated.decrypt(), PAGE_EXECUTE_READ);
            //"HellIsUs-Win64-Shipping.exe" + 3D73BC2 - 48 8B 05 D7 F7 6E 05 - mov rax, ["HellIsUs-Win64-Shipping.exe" + 94633A0]
            //"HellIsUs-Win64-Shipping.exe" + 3D73BC9 - 44 39 38             - cmp[rax], r15d
            //"HellIsUs-Win64-Shipping.exe" + 3D73BCC - 7F 07                - jg "HellIsUs-Win64-Shipping.exe" + 3D73BD5
            //"HellIsUs-Win64-Shipping.exe" + 3D73BCE - 44 89 BB 1C 20 00 00 - mov[rbx + 0000201C], r15d
            //"HellIsUs-Win64-Shipping.exe" + 3D73BD5 - 43 8B 04 26          - mov eax, [r14 + r12]

            if (!CAaddress)
                logger->warn("Chromatic aberrations signature not found. Maybe your game has been updated and is no more compatible with this plugin.");
            else {
                logger->info("Chromatic aberrations signature found at address: 0x{:X}.", reinterpret_cast<uintptr_t>(CAaddress));
            }
        }

        if (Vignettingaddress == nullptr) {
            constexpr auto VignettingStringObfuscated = make_obfuscated<0x4A>("8B ?? 83 ?? ?? 7D ?? 44 89");
            Vignettingaddress = Memory::AOBScan(gameExecutable, VignettingStringObfuscated.decrypt(), PAGE_EXECUTE_READ);
            //"HellIsUs-Win64-Shipping.exe" + 3D73C64 - 8B 08                - mov ecx, [rax]
            //"HellIsUs-Win64-Shipping.exe" + 3D73C66 - 83 F9 02             - cmp ecx, 02
            //"HellIsUs-Win64-Shipping.exe" + 3D73C69 - 7D 09                - jnl "HellIsUs-Win64-Shipping.exe" + 3D73C74
            //"HellIsUs-Win64-Shipping.exe" + 3D73C6B - 44 89 BB C8 22 00 00 - mov[rbx + 000022C8], r15d
            //"HellIsUs-Win64-Shipping.exe" + 3D73C72 - EB 05                - jmp "HellIsUs-Win64-Shipping.exe" + 3D73C79

            if (!Vignettingaddress)
                logger->warn("Vignetting signature not found. Maybe your game has been updated and is no more compatible with this plugin.");
            else {
                logger->info("Vignetting signature found at address: 0x{:X}.", reinterpret_cast<uintptr_t>(Vignettingaddress));
                Vignettingaddress += 0x5;
            }
        }

        if (Fogaddress == nullptr) {
            constexpr auto FogStringObfuscated = make_obfuscated<0x4A>("F6 ?? ?? ?? ?? 74 ?? 48 8B ?? ?? ?? ?? ?? 83 78 ?? ?? 75 ?? B3");            
            Fogaddress = Memory::AOBScan(gameExecutable, FogStringObfuscated.decrypt(), PAGE_EXECUTE_READ);
            //"HellIsUs-Win64-Shipping.exe" + 22B77C8 - 74 11                - je "HellIsUs-Win64-Shipping.exe" + 22B77DB
            //"HellIsUs-Win64-Shipping.exe" + 22B77CA - 48 8B 05 8F 23 08 07 - mov rax, ["HellIsUs-Win64-Shipping.exe" + 9339B60]
            //"HellIsUs-Win64-Shipping.exe" + 22B77D1 - 83 78 04 01          - cmp dword ptr[rax + 04], 01
            //"HellIsUs-Win64-Shipping.exe" + 22B77D5 - 75 04                - jne "HellIsUs-Win64-Shipping.exe" + 22B77DB
            //"HellIsUs-Win64-Shipping.exe" + 22B77D7 - B3 01                - mov bl, 01
            //"HellIsUs-Win64-Shipping.exe" + 22B77D9 - EB 02                - jmp "HellIsUs-Win64-Shipping.exe" + 22B77DD
            //"HellIsUs-Win64-Shipping.exe" + 22B77DB - 32 DB                - xor bl, bl

            if (!Fogaddress)
                logger->warn("Fog signature not found. Maybe your game has been updated and is no more compatible with this plugin.");
            else {
                logger->info("Fog signature found at address: 0x{:X}.", reinterpret_cast<uintptr_t>(Fogaddress));
                Fogaddress += 0x12;
            }            
        }

        if (FOVaddress && FOVOtheraddress && Aspectaddress && DOFaddress && CAaddress && Vignettingaddress && Fogaddress) {
            logger->info("All AOB signatures found. Ready to patch...");
            AOBScanDone = true;
        }

        logger->info("--------------- AOB scan finished ---------------");
    }
    if (g_fix_enabled) {
        if (FOVaddress) FOVFixEnabled(g_fov_fix_enabled || g_aspect_fix_enabled);
        if (Aspectaddress) AspectFixEnabled(g_aspect_fix_enabled);
        if (DOFaddress) DOFFixEnabled(g_DOF_fix_enabled);
        if (CAaddress) CAFixEnabled(g_CA_fix_enabled);
        if (Vignettingaddress) VignettingFixEnabled(g_Vignetting_fix_enabled);
        if (Fogaddress) FogFixEnabled(g_Fog_fix_enabled);
    }
    else {
        if (FOVaddress) FOVFixEnabled(false);
        if (Aspectaddress) AspectFixEnabled(false);
        if (DOFaddress) DOFFixEnabled(false);
        if (CAaddress) CAFixEnabled(false);
        if (Vignettingaddress) VignettingFixEnabled(false);
        if (Fogaddress) FogFixEnabled(false);
        logger->info("All fixes disabled.");
    }
}

// Setters for Reshade addon call
extern "C" __declspec(dllexport) void SetFOVFixEnabled(bool enabled, bool init)
{
    g_fov_fix_enabled = enabled;
    if (!init) FOVFixEnabled(g_fov_fix_enabled || g_aspect_fix_enabled);
}

extern "C" __declspec(dllexport) void SetAspectRatioFixEnabled(bool enabled, bool init)
{
    g_aspect_fix_enabled = enabled;
    if (!init) AspectFixEnabled(g_aspect_fix_enabled);
}

extern "C" __declspec(dllexport) void SetDOFFixEnabled(bool enabled, bool init)
{
    g_DOF_fix_enabled = enabled;
    if (!init) DOFFixEnabled(g_DOF_fix_enabled);
}

extern "C" __declspec(dllexport) void SetCAFixEnabled(bool enabled, bool init)
{
    g_CA_fix_enabled = enabled;
    if (!init) CAFixEnabled(g_CA_fix_enabled);
}

extern "C" __declspec(dllexport) void SetVignettingFixEnabled(bool enabled, bool init)
{
    g_Vignetting_fix_enabled = enabled;
    if (!init) VignettingFixEnabled(g_Vignetting_fix_enabled);
}

extern "C" __declspec(dllexport) void SetFogFixEnabled(bool enabled, bool init)
{
    g_Fog_fix_enabled = enabled;
    if (!init) FogFixEnabled(g_Fog_fix_enabled);
}

extern "C" __declspec(dllexport) void SetFOV(int fov)
{
    g_AdditionalFOVValue = fov;
}

// Getters for Reshade addon call
extern "C" __declspec(dllexport) float GetFOVIn() {
    return g_FOV_In;
}

extern "C" __declspec(dllexport) float GetCompensatedFOV() {
    return g_Compensated_FOV;
}

extern "C" __declspec(dllexport) float GetFOVOut() {
    return g_FOV_Out;
}

// Code injection functions
static void FOVFixEnabled(bool fix_enabled) {
    if (g_fix_enabled && fix_enabled && FOVaddress != nullptr) {
        if (!FOVHook) { // Hook only once
            FOVHook = safetyhook::create_mid(FOVaddress,
                [](SafetyHookContext& ctx) {
                    g_FOV_In = ctx.xmm0.f32[0];
                    if (g_aspect_fix_enabled)
                        g_Compensated_FOV = ctx.xmm0.f32[0] = Maths::CompensateHorizontalFOV(g_FOV_In, baseAspect, aspectRatio);
                    else
                        g_Compensated_FOV = ctx.xmm0.f32[0];
                    if (g_FOV_In != PDA_FOV)
                        g_FOV_Out = ctx.xmm0.f32[0] += (g_fov_fix_enabled ? g_AdditionalFOVValue : 0);
                    else g_FOV_Out = ctx.xmm0.f32[0];
                });
        }
        else FOVHook.enable();
        logger->info("FOV fix enabled");
    }
    if (!fix_enabled) {
        if (FOVHook) FOVHook.disable();
        logger->info("FOV fix disabled");
    }
}

static void AspectFixEnabled(bool fix_enabled) {
    if (g_fix_enabled && fix_enabled && Aspectaddress) {
        if (!AspectHook) {
            AspectHook = safetyhook::create_mid(Aspectaddress,
                [](SafetyHookContext& ctx) {
                    ctx.rax = *reinterpret_cast<uint32_t*>(&aspectRatio);
                });
        }
        else AspectHook.enable();
        logger->info("Aspect fix enabled");
    }
    if (!fix_enabled) {
        if (AspectHook) AspectHook.disable();
        logger->info("Aspect ratio fix disabled");
    }
}

// Memory patch fixes
static void DOFFixEnabled(bool fix_enabled) {
    if (g_fix_enabled && fix_enabled && DOFaddress) {
        Memory::PatchBytes(DOFaddress, "\x31\xF6\x90", 3); // xor esi,esi r.DepthOfFieldQuality = 0
        logger->info("Depth of field fix enabled");
    }
    if (!fix_enabled && DOFaddress) {
        Memory::RestoreBytes(DOFaddress);
        logger->info("Depth of field fix disabled");
    }
}

static void CAFixEnabled(bool fix_enabled) {
    if (g_CA_fix_enabled && fix_enabled && CAaddress) {
        Memory::PatchBytes(CAaddress, "\x90\x90", 2); // NOP jg "HellIsUs-Win64-Shipping.exe"+3D73BD5
        logger->info("Chromatics aberrations fix enabled");
    }
    if (!fix_enabled && CAaddress) {
        Memory::RestoreBytes(CAaddress);
        logger->info("Chromatics aberrations fix disabled");
    }
}

static void VignettingFixEnabled(bool fix_enabled) {
    if (g_fix_enabled && fix_enabled && Vignettingaddress) {
        Memory::PatchBytes(Vignettingaddress, "\x31\xC9", 2); // xor ecx,ecx r.Tonemapper.Quality=0
        logger->info("Vignetting fix enabled");
    }
    if (!fix_enabled && Vignettingaddress) {
        Memory::RestoreBytes(Vignettingaddress);
        logger->info("Vignetting fix disabled");
    }
}

static void FogFixEnabled(bool fix_enabled) {
    if (g_fix_enabled && fix_enabled && Fogaddress) {
        if (!FogHook) { // Hook only once
            FogHook = safetyhook::create_mid(Fogaddress,
                [](SafetyHookContext& ctx) {
                    ctx.rflags &= ~0x40; // ZF=0
                });
        }
        logger->info("Fog fix enabled");
    }
}

static void InitializeLogger()
{
    try
    {
        std::filesystem::path log_path = std::filesystem::absolute(PLUGIN_LOG);
        if (std::filesystem::exists(log_path))
            std::filesystem::remove(log_path);
        logger = std::make_shared<spdlog::logger>("Hell Is Us", std::make_shared<spdlog::sinks::rotating_file_sink_st>(PLUGIN_LOG, 10 * 1024 * 1024, 1));
        logger->flush_on(spdlog::level::debug); // Flush automatically
    }
    catch (const spdlog::spdlog_ex& ex)
    {
        std::string plugin_error_message = "Could not open " + PLUGIN_LOG;
        MessageBoxA(nullptr, plugin_error_message.c_str(), "Logger Error", MB_ICONERROR | MB_OK);
    }
}

// Standard dll entry
BOOL APIENTRY DllMain(HMODULE hModule, DWORD reason, LPVOID)
{
    if (reason == DLL_PROCESS_ATTACH)
    {
        InitializeLogger();
        logger->info("Plugin {} loaded.", PLUGIN_NAME);
    }
    else if (reason == DLL_PROCESS_DETACH)
    {
        logger->info("Plugin {} unloaded.", PLUGIN_NAME);
        spdlog::drop_all();
    }
    return TRUE;
}